--Global Working Parameters
global EscapeEnable = true
global OpenPath = undefined

global SrcObj = undefined
global TargetObj = undefined

-- Arktos Skin Transfer
macroScript ArktosReSkinner
buttontext:"Objects ReSkinner..." category:"ArktosInt"
(
rollout ArktosReSkiner "ReSkinner" width:208 height:400
(
	button BtnAbout "About" pos:[8,336] width:91 height:20
	button BtnReSkin "ReSkinMe!" pos:[112,368] width:90 height:20
	groupBox grp1 "SelectionOptions" pos:[10,120] width:190 height:88
	groupBox grp2 "ReSkinOptions" pos:[10,10] width:190 height:105
	button BtnCancel "Cancel" pos:[8,368] width:91 height:20
	button BtnSaveSetting "SaveSettings" pos:[110,336] width:91 height:20
	groupBox grp3 "TransferProgress" pos:[8,224] width:190 height:104
	progressBar PBCurVrt "ObjectExportProgress" pos:[16,296] width:170 height:16 color:(color 30 10 190)
	label all01 "Current Vertex:" pos:[16,280] width:80 height:13
	label LBL_CurVert "0" pos:[94,280] width:50 height:16
	label lbl5 "Total:" pos:[16,240] width:29 height:17
	label PercentScnDone "0" pos:[46,240] width:50 height:16
	progressBar PBCurTotal "TotalExportProgress" pos:[16,256] width:170 height:16 color:(color 30 10 190)
	label lbl27 "Rigging Smoth :" pos:[21,91] width:105 height:16
	
	checkbox VtxHer "Use Heuristic Analysis" pos:[20,50] width:170 height:20 checked:false tristate:2 enable:false
	checkbox DelObjs "Delete SRC Object" pos:[20,70] width:170 height:20 checked:false enable:false
	checkbox VtxLinear "Use Linear Interpolation" pos:[20,30] width:170 height:20 checked:false tristate:2 enable:false
	
	spinner BoneEnvScale "" pos:[131,91] width:62 height:16 range:[1,100,1] type:#integer
	
	pickbutton TargetObjSel "Select Target Object..." pos:[16,176] width:176 height:20
	pickbutton SrcObjSel "Select Source Object..." pos:[16,144] width:176 height:20
	
	--Write Ini file function start here
	fn ReSkinWriteIniFun = 
	(
		local IniFileName = (GetDir #startupScripts) + "/ArktosReSkin.ini"
		
		--ini file not exist create default settings	
		local IniFile = Createfile IniFileName 
			
		format "%\n" VtxHer.checked  to:IniFile
		format "%\n" VtxHer.enabled  to:IniFile
			
		format "%\n" DelObjs.checked  to:IniFile
		format "%\n" DelObjs.enabled  to:IniFile
			
		format "%\n" VtxLinear.checked  to:IniFile
		format "%\n" VtxLinear.enabled  to:IniFile
			
		format "%\n" BoneEnvScale.range  to:IniFile
		
		close IniFile
			
		return IniFile
	)
	
	--save settings start here
		on BtnSaveSetting pressed do
		(
			ReskinWriteIniFun()
		)
		
		--First start save setings procedure after firs open GUI
		on ArktosReSkiner open do
		(
			local IniFileName = (GetDir #startupScripts) + "/ArktosReskin.ini"
			if ((getfiles IniFilename).count == 0) then
			(
				--ini file not exist create default setting
				ReSkinWriteIniFun()
			)	
			else
			(
				-- ini file exist and read settings from it
				IniFile = openfile IniFileName
				
				VtxHer.checked = ReadValue IniFile
				VtxHer.enabled = ReadValue IniFile
				
				DelObjs.checked = ReadValue IniFile
				DelObjs.enabled = ReadValue IniFile
				
				VtxLinear.checked = ReadValue IniFile
				VtxLinear.enabled = ReadValue IniFile
				
				BoneEnvScale.range = ReadValue IniFile
				
				close IniFile
			)
		)
	
	-- Display About
		on BtnAbout pressed do
		(
			rollout AboutArktos "About" width:296 height:152
			(	 
				bitmap bmp1 "Bitmap" pos:[8,8] width:280 height:80 fileName: "ArktosLogo.bmp" 
				button btn1 "Ok" pos:[104,140] width:88 height:24
				label lbl13 "All Rights Reserved, 2013 Arktos Entertainment. v1.05" pos:[10,96] width:275 height:30 align:#right style_sunkenedge:true
				on btn1 pressed do destroyDialog(AboutArktos)
			)
			createDialog AboutArktos 296 172
		)
	--Pick to Target Object
	on TargetObjSel picked Obj do
	(
		if Obj != undefined then
		(
			select Obj
			for mesh in selection do
			(
				if superclassof mesh == GeometryClass and ClassOf mesh == Editable_mesh then
				(
					TargetObjSel.text = Obj.name
					global TargetObj = Obj
				)
				else
				(
					messagebox ("Please convert or use Editable mesh for Target Object!") title: "Warning!"
				)
			)
		)
	)
	--Pick to SrcObject
	on SrcObjSel picked Obj do
	(
		if Obj != undefined then
		(
			select Obj
			for mesh in selection do
			(
				if superclassof mesh == GeometryClass and ClassOf mesh == Editable_mesh then
				(
					if Obj.modifiers[#skin] != undefined then
					(
						SrcObjSel.text = Obj.name
						global SrcObj = Obj
					)
					else
					(
						messagebox ("Please Add Skin Modyfier to Sourche Object!") title: "Warning!"
					)
				)
				else
				(
					messagebox ("Please convert or use Editable mesh for Sourche Object!") title: "Warning!"
				)
			)
		)
	)
	--Cancel:)	
	on BtnCancel pressed do destroydialog ArktosReSkiner
	
	--Simple Reskin:)
	on BtnReSkin pressed do
	(
		--check selection Source
		if SrcObj !=undefined then
		(
			--check selection target
			if TargetObj !=undefined then
			(
				--SkinStart!
				SrcBonesArray = #()
				BoneArray = #()
				BonePerVert  = #()
				WeightArray = #()
				IndexArray = #()
				global T_Index =0
				
				--go to modify mode. Thi is important.
				max modify mode
				select TargetObj
				mySkin = Skin()
				addModifier TargetObj mySkin
				
				--Create bones array to transfer to Target Object
				SrcBoneNum = skinOps.GetNumberBones SrcObj.modifiers[#skin]
				for i = 1 to SrcBoneNum do
				(
					SrcBonesArray[i]= getnodebyname ((skinOps.GetBoneName SrcObj.modifiers[#skin] i 0) as string)
					
					-- transfer bones to target object
					skinOps.addBone mySkin SrcBonesArray[i] 0
				)

				--Make Arrays For Skining
				select SrcObj
				AllVerts = skinOps.GetNumberVertices SrcObj.modifiers[#skin]
				a = 1
				For vert = 1 to AllVerts do
				(
					-- Get number of bones per verts	
					MyBonesPerVert = skinOps.GetVertexWeightCount SrcObj.modifiers[#skin] vert 	
					for Mybone = 1 to MyBonesPerVert do
					(	
						-- get bones index and weights 
						BoneIndex = skinOps.GetVertexWeightBoneID SrcObj.modifiers[#skin] vert Mybone
						BoneWeight = skinOps.GetVertexWeight SrcObj.modifiers[#skin] vert Mybone
						BonePerVert[a] = MyBonesPerVert
						BoneArray[a] = BoneIndex
						WeightArray[a] = BoneWeight
						IndexArray[a] = vert
						a = a+1
						
						-- update progress bar
						PBCurVrt.value = 100.*vert/AllVerts
						LBL_CurVert.caption = PBCurVrt.value as string +"%"
					)
				)
				
				-- update TOTAL progress bar
					PBCurTotal.value = 100.*20/60
					PercentScnDone.caption = PBCurTotal.value as string +"%"
				
				-- reset progress bar
				PBCurVrt.value = 0
				LBL_CurVert.caption = "Done!"
				
				-- prepare to transfer stored Weights info
				select TargetObj
				
				--make snapshot all mesheh in frame 0
				TargetTreeObj = snapshotasmesh TargetObj
				SrcTreeObj =  snapshotasmesh SrcObj
				
				
				
				-- main loop. Take every vertex in SRC object and search closest. 
				for Tvert =1  to TargetTreeObj.numverts do
				(
					--search closest vertex
					T_Index = 0
					Result = 1e9
					For vert = 1 to SrcTreeObj.numverts do
					(
						Point_a = getvert TargetTreeObj Tvert
						Point_b = getvert SrcObj vert
						DstLocal = distance Point_a Point_b
						if DstLocal < Result then
						(
							Result = DstLocal
							-- index closest SRC Obj vertex to current vertex in Target object
							T_Index = vert
						)
					)
					
					-- Search real index in plain array
					For f = 1 to IndexArray.count do
					(
						if IndexArray[f] == T_Index then
						(
							-- make arrays for current vertex. It is important! You can`t asign every weight one by one. You need assign by arrays one time!
							boneList = #()
							weightList = #()
							for z =(f) to (f+BonePerVert[f]-1) do
							(
								append boneList BoneArray[z]
								append weightList WeightArray[z]
								
								--Reset Skin Parameters. It is Magic but is work!
								skinOps.ReplaceVertexWeights TargetObj.modifiers[#skin] TVert 1 1.0
							)
							
							--Skin current vertex in Target Obj
							skinOps.ReplaceVertexWeights SrcObj.modifiers[#skin] TVert boneList weightList
							
							
							
							exit
						)
						
					)
					-- update progress bar
					PBCurVrt.value = 100.*Tvert/TargetTreeObj.numverts
					LBL_CurVert.caption = PBCurVrt.value as string +"%"
				)
				
				-- reset progress bar
				PBCurVrt.value = 0
				LBL_CurVert.caption = "Done!"
				
				-- reset TOTAL progress bar
				PBCurTotal.value = 0
				PercentScnDone.caption = "Done!"
				
				free SrcBonesArray
				free BoneArray
				free BonePerVert
				free WeightArray
				free IndexArray
					
				-- delete target object if you want
				if DelObjs.checked == true then delete TargetObj
			)
			else
			(
				messagebox ("Please Select Target Object to transfer Skin Parameters First!") title: "Warning!"
			)
		)
		else
		(
			messagebox ("Please Select Source Object to transfer Skin Parameters First!") title: "Warning!"
		)
	)
)
createDialog ArktosReSkiner width:208 height:400
)
-- Arktos Bone Capture
macroScript ArktosBoneCap
buttontext:"Animation To Bones..." category:"ArktosInt"
(
	

	rollout AnimationToBonesBaker "Animation To Bones Baker" width:210 height:455
	(
		button BtnObjExport "ObjectToBones!" pos:[110,395] width:91 height:20
		button BtnVrtxExport "VertexToBones!" pos:[110,425] width:90 height:20
		
		button BtnCancel "Cancel" pos:[10,425] width:91 height:20
		button BtnSaveSetting "SaveSettings" pos:[10,395] width:91 height:20
		groupBox grp1 "VertexToBonesOptions" pos:[10,120] width:190 height:145
		groupBox grp2 "ObjectsToBonesOptions" pos:[10,10] width:190 height:105
		groupBox grp3 "ExportProgress" pos:[10,270] width:190 height:110
		progressBar pbObj "ObjectExportProgress" pos:[20,350] width:170 height:16 color:(color 30 10 190)
		label lbl24 "Generated Bone Size:" pos:[20,90] width:110 height:16
		label lbl4 "Current Object:" pos:[20,330] width:80 height:13
		label PercentObjDone "0" pos:[98,330] width:50 height:16
		label lbl5 "Total:" pos:[20,285] width:29 height:17
		label PercentScnDone "0" pos:[50,285] width:50 height:20
		progressBar pbScn "TotalExportProgress" pos:[20,305] width:170 height:16 color:(color 30 10 190)
		label lbl27 "Rigging Smoth %:" pos:[20,180] width:105 height:16
		label lbl25 "Generation Vertex %:" pos:[20,160] width:110 height:16
		label lbl26 "Bone Affect Limit :" pos:[20,140] width:105 height:16
		
		checkbox BoneTraject "Display BonesTrajectory" pos:[20,30] width:170 height:20 checked:true
		checkbox BonesBBox "Display Bones As Box" pos:[20,50] width:170 height:20 checked:true
		checkbox DelSRCObj "Delete SRC Object" pos:[20,200] width:170 height:20 checked:true
		checkbox DelObjs "Delete SRC Objects" pos:[20,70] width:170 height:20 checked:true
		checkbox BoneRnd "Randomize Bone Position" pos:[20,220] width:170 height:20 checked:true
		
		label BonePerFace "Skin at Frame:" pos:[20,240] width:170 height:20
		
		spinner BoneScaleMult "" pos:[130,90] width:62 height:16 range:[0.1,100,1.0] type:#float
		spinner BoneAffect "" pos:[130,140] width:62 height:16 range:[1,100,4] type:#integer
		spinner BoneStep "" pos:[130,160] width:62 height:16 range:[1,100,1] type:#integer
		spinner BoneEnvScale "" pos:[130,180] width:62 height:16 range:[1,100,1] type:#integer
		
		spinner SkinAtFrame "" pos:[130,240] width:62 height:16 range:[0,1000,1] type:#integer
		
		
		on BtnVrtxExport pressed do
		(
			if (selection.count > 0) then
			(
				-- create root bone
				BoneRoot = BoneSys.createBone [0,0,0] [0,BoneScaleMult.value,0] [0,0,1]
				BoneRoot.rotation = (eulerAngles 0 0 0)
				BoneRoot.height = (BoneScaleMult.value * 0.2)
				BoneRoot.width = (BoneScaleMult.value * 0.2)
				BoneRoot.name = "Bone_Root"
				
				if BonesBBox.checked == true then
				(
					BoneRoot.boxmode = on 
				)
				else
				(
					BoneRoot.boxmode = off
				)
				
				for Obj in selection do
				(
					-- Reset Object Pivot
					CenterPivot Obj
					global ObjTempPos = Obj.position
					Obj.position =  [0,0,0]
					
					MyEdtMsh = Edit_Mesh ()
					addModifier Obj MyEdtMsh
					
					-- Bones Array for Skining
					BonesArray = #()
					if BoneRnd.checked == true then
					(
						step = 1
					)
					else
					(
						step = (100/BoneStep.value) as integer
					)
						
					-- create Bones by vertex
					for i = 1 to Obj.mesh.numverts by step do 
					(		
						-- make point3
						vert = getVert Obj i
						XElem = vert.x + BoneScaleMult.value
						YElem = vert.y + BoneScaleMult.value
						ZElem = vert.z + BoneScaleMult.value
						NewBoneTarget = [(XElem),YElem ,ZElem ]
						
						-- Create Bone
						NewBone=BoneSys.createBone (getVert Obj i) NewBoneTarget Obj.dir
						NewBone.rotation = (eulerAngles 0 0 0)
						NewBone.height = (BoneScaleMult.value * 0.2)
						NewBone.width = 	(BoneScaleMult.value * 0.2)
						
						-- GUI parameters check
						if BoneTraject.checked == true then 
						(
							NewBone.showTrajectory = on
						)
						else
						(
							NewBone.showTrajectory = off
						)
						if BonesBBox.checked == true then
						(
							NewBone.boxmode = on 
						)
						else
						(
							NewBone.boxmode = off
						)
						-- make Array to colect created bones in one array
						BonesArray[i] = NewBone
						
						-- update progress bar
						pbObj.value = 100.*i/Obj.mesh.numverts
						PercentObjDone.caption = pbObj.value as string +"%"
					)
					-- reset progress bar
					pbObj.value = 0
					PercentObjDone.caption = "Done!"
					
					-- update global bar
					pbScn.value = 100.*20/100
					PercentScnDone.caption = pbScn.value as string +"%"
					
					-- Copy Animation From Parent Object to New Bone
					for i = 1 to Obj.mesh.numverts by step do 
					(	
						-- Link to root_bone
						BonesArray[i].parent = $Bone_Root
						
						-- Create standard transform controller to bake keys into
						p = PRS()
						p.position.controller = linear_position()       
						p.rotation.controller = tcb_rotation()       
						p.scale.controller = linear_scale()
							
						-- setup current vertex matrix transform
						faceNormal = in coordsys world (getNormal Obj i)
						worldUpVector = [0,0,1]
						rightVector = normalize (cross worldUpVector faceNormal)
						upVector = normalize ( cross rightVector faceNormal )
							
						-- Set initial transform
						at time animationRange.start, with animate off, in coordsys world 
						(
							p.value = matrix3 rightVector upVector faceNormal (getVert Obj i)
						)         
						
						-- Capture keys to temp Controllers "p"
						for t = animationRange.start to animationRange.end do
						(   
							at time t, with animate on, in coordsys world
							(
								-- setup current vertex matrix transform
								faceNormal = in coordsys world (getNormal Obj i)
								worldUpVector = [0,0,1]
								rightVector = normalize (cross worldUpVector faceNormal)
								upVector = normalize ( cross rightVector faceNormal )
								p.value = matrix3 rightVector upVector faceNormal (getVert Obj i)
							)
						)
							
						-- Asign All Captured Keys To Bone
						BonesArray[i].transform.controller = p
						
						-- update progress bar
						pbObj.value = 100.*i/Obj.mesh.numverts
						PercentObjDone.caption = pbObj.value as string +"%"
					)
						
					-- reset progress bar
					pbObj.value = 0
					PercentObjDone.caption = "Done!"
						
					-- update global bar
					pbScn.value = 100.*70/100
					PercentScnDone.caption = pbScn.value as string +"%"
						
					-- Prepare Object to Skin
					at time SkinAtFrame.value, with animate off, in coordsys world
					(
						--make copy from created object and Skin with parameters from GUI
						ObjSkin = copy Obj
						
						-- Restore Object Captured position
						Obj.position =  ObjTempPos
						deleteModifier Obj MyEdtMsh
						-- Reset Object Pivot
						CenterPivot ObjSkin
						ResetXForm ObjSkin
						collapseStack ObjSkin
						
						if DelSRCObj.checked == true then delete Obj
							
						--convertToPoly ObjSkin
							
						-- modify mode must be!
						max modify mode
						mySkin = Skin()
						addModifier ObjSkin mySkin
						
						mySkin.initialStaticEnvelope = false
						MySkin.ref_frame = SkinAtFrame.value
						mySkin.initialOuterEnvelopePercent = BoneEnvScale.value
						mySkin.bone_Limit = BoneAffect.value
						modPanel.setCurrentObject mySkin
							
						--random delete bones by selected persentage
						if BoneRnd.checked == true then
						(
							(
								candidatesArray = BonesArray
								
								-- Temp Array to preparet to delte objects
								deathRowArray = #()
								thePercentage = (100 - BoneStep.value) as integer
							
								-- Calculate the number of objects to delete:
								numberToDelete = (thePercentage / 100.0 * candidatesArray.count) as integer
									
								-- Loop until the deathRow array is filled -- with the desired number of objects:
								while deathRowArray.count < numberToDelete do
								(
									--generate new random index --if not already chosen, add it to the deathrow array
									newIndex = random 1 candidatesArray.count
									if findItem deathRowArray candidatesArray[newIndex] == 0 do
									append deathRowArray candidatesArray[newIndex]
								)
								
							)
						)
						-- add every bones to skined object
						for i = 1 to BonesArray.count by step do
						(
							skinOps.addBone mySkin (BonesArray[i]) 1
								
							-- update progress bar
							pbObj.value = 100.*i/BonesArray.count
							PercentObjDone.caption = pbObj.value as string +"%"
						)
							
						-- if random bone position checked then delete @Death@ bones
						if BoneRnd.checked == true then delete deathRowArray
							
						-- reset progress bar
						pbObj.value = 0
						PercentObjDone.caption = "Done!"
					)
				)
				
				
				-- reset progress bar
				pbScn.value = 0
				PercentScnDone.caption = "Done!"
			)
			else
			(
				messagebox ("Select any Objects for operation!") title: "Warning!"
			)
		)
		
		-- Export many Objects to Single Skined Mesh
		on BtnObjExport pressed do 
		(
			if (selection.count > 0) then
			(	
					-- create root bone
					BoneRoot = BoneSys.createBone [0,0,0] [0,BoneScaleMult.value,0] [0,0,1]
					BoneRoot.rotation = (eulerAngles 0 0 0)
					BoneRoot.height = (BoneScaleMult.value * 0.2)
					BoneRoot.width = (BoneScaleMult.value * 0.2)
					BoneRoot.name = "Bone_Root"
				
					if BonesBBox.checked == true then
					(
						BoneRoot.boxmode = on 
					)
					else
					(
						BoneRoot.boxmode = off
					)
				-- Arrays For Skinig
				ObjArray = #()
				ObjVrtNum = #()
				BonesArray = #()
					
				-- Ugly programing stylw for global progrees bar update
				global i = 1
					
				at time animationRange.start, with animate off, in coordsys world
				(
					for Obj in selection do
					(
					-- Reset Object Pivot
					--CenterPivot Obj
					convertToPoly Obj
						
					-- Add To Arrays Skining Info
					ObjArray[i] = Obj
					ObjVrtNum[i] = Obj.numVerts
						
					-- make point3
					XElem = Obj.pos.x
					YElem = Obj.pos.y
					ZElem = Obj.pos.z
					NewBoneTarget = [(XElem + BoneScaleMult.value),YElem ,ZElem ]
							
					-- Create Bone
					NewBone=BoneSys.createBone Obj.position NewBoneTarget Obj.dir
					NewBone.rotation = (eulerAngles 0 0 0)
					NewBone.height = (BoneScaleMult.value * 0.2)
					NewBone.width = 	(BoneScaleMult.value * 0.2)
						
					-- Asign GUI settings to created Bone
					if BoneTraject.checked == true then 
					(
						NewBone.showTrajectory = on
					)
					else
					(
						NewBone.showTrajectory = off
					)
					if BonesBBox.checked == true then
					(
						NewBone.boxmode = on 
					)
					else
					(
						NewBone.boxmode = off
					)
						
					-- Add Bones Info to Array for Skining
					BonesArray[i] = NewBone
					
					-- Link to root_bone
					BonesArray[i].parent = $Bone_Root
					
					-- Copy Animation From Parent Object to New Bone
					p = PRS()
					p.position.controller = linear_position()       
					p.rotation.controller = tcb_rotation()       
					p.scale.controller = linear_scale()
						
					-- Set initial transform
					at time animationRange.start, with animate off, in coordsys world 
					(
						p.value = Obj.transform
					)
						
					-- Capture keys to temp Controllers "p"
					for t = animationRange.start to animationRange.end by 1 do
					(
						at time t, with animate on, in coordsys world
						(
							p.value = Obj.transform                  
						)
					)
					
					-- Asign All Captured Keys To Bone
					NewBone.transform.controller = p
					
					-- Ugly Update Total bar. need Fix
					k = selection
					pbScn.value = 100.*i/k.count
					PercentScnDone.caption = pbScn.value as string +"%"
					i = i +1
				)
			)
				
			-- reset progress bar
			pbScn.value = 0
			PercentScnDone.caption = "Done!"
				
			-- atach other objects to first
			at time animationRange.start, with animate off, in coordsys world
			(
				maxops.clonenodes ObjArray actualNodeList:&ObjArray newNodes:&ObjArrayNew cloneType:#copy
				
				for i = 2 to ObjArrayNew.count do
				(
					ObjArrayNew[1].attach ObjArrayNew[i] ObjArrayNew[1] 
				)
			)
			
			-- some "bad programing" Reasign Label
			if DelObjs.checked == true then
			(
				p = ObjArrayNew[1]
				for f = 1 to ObjArray.count do
				(	
					delete ObjArray[f]
				)
			)
			else
			(
				p = ObjArrayNew[1]
			)
				
			-- select skined object
			select p
			
			--Clear "Bad" UVW
			for f = 3 to 128 do
			(
				channelInfo.ClearChannel p f
			)
			
			-- collapse Stacked UVW
			convertToPoly p
			
			max modify mode
			--ResetPivot p
		
			-- add user defined property for corect export to our engine
			setUserProp p "NoVertexJoin" 1
				
			--add skin
			mySkin = Skin()
			addModifier p mySkin
			modPanel.setCurrentObject mySkin
				
			-- add every bones to skined object
			for i = 1 to BonesArray.count do
			(
				skinOps.addBone mySkin (BonesArray[i]) 1
			)
				
			--reset all vertex weights
			myWeights = (for i = 1 to p.numVerts collect 0.0)
			for f in 1 to (skinOps.GetNumberBones mySkin) do
			(	
				for v in 1 to p.numVerts do
				(
					--unnormalize the vertex - otherwise it's going to sum up straight to the 1.0 ( for whatever reason )
					skinOps.unNormalizeVertex mySkin v true
					skinOps.ReplaceVertexWeights mySkin v f myWeights[v]
				)
					
				-- update progress bar
				pbObj.value = 100.*f/p.numVerts
				PercentObjDone.caption = pbObj.value as string +"%"
			)
				
			--now, every vertex as default has the weight of 0.0
			-- asign new vertex weight
			ObjVrtNum.count
			global AddVrt = 0
			for i in 1 to (skinOps.GetNumberBones mySkin) do
			(
				for f in 1 to ObjVrtNum[i] do
				(
					skinOps.ReplaceVertexWeights mySkin (f+AddVrt) i 1.0
				)
				AddVrt = AddVrt + ObjVrtNum[i]
			)
			
			-- reset progress bar
			pbObj.value = 0
			PercentObjDone.caption = "Done!"
			
			-- Reset Controllers IK
			deleteKeys p #allKeys
			
			--Delete controllers in the list POSITION_List if exist/ Only for PhysX or MassFX simulation.
			f = p.pos.controller as string
	
			if f == "Controller:Position_List" then
			(	
				
				a = p.pos.controller
				a.delete a.count
				--and rotation
				a = p.rotation.controller
				a.delete a.count
			)
			
			
		
			
			clearSelection()
		)
		else
		(
			messagebox ("Select any Objects for operation!") title: "Warning!"
		)	
	)
	
--Close Window	
on BtnCancel pressed do destroyDialog(AnimationToBonesBaker)
	
--Write Ini file function start here
fn BoneWriteIniFun = 
	(
		local IniFileName = (GetDir #startupScripts) + "/ArktosBonesTools.ini"
		
		--ini file not exist create default settings	
		local IniFile = Createfile IniFileName 
			
		format "%\n" BoneTraject.checked  to:IniFile
		format "%\n" BoneTraject.enabled  to:IniFile
			
		format "%\n" BonesBBox.checked  to:IniFile
		format "%\n" BonesBBox.enabled  to:IniFile
			
		format "%\n" DelSRCObj.checked  to:IniFile
		format "%\n" DelSRCObj.enabled  to:IniFile
			
		format "%\n" DelObjs.checked  to:IniFile
		format "%\n" DelObjs.enabled  to:IniFile
			
		format "%\n" BoneRnd.checked  to:IniFile
		format "%\n" BoneRnd.enabled  to:IniFile
			
			
		format "%\n" BoneScaleMult.range  to:IniFile
		format "%\n" BoneAffect.range  to:IniFile
		format "%\n" BoneStep.range  to:IniFile
		format "%\n" BoneEnvScale.range  to:IniFile
			
		format "%\n" SkinAtFrame.range  to:IniFile
			
		close IniFile
			
		return IniFile
	)
		
		--save settings start here
		on BtnSaveSetting pressed do
		(
			BoneWriteIniFun()
		)
		
		--First start save setings procedure after firs open GUI
		on AnimationToBonesBaker open do
		(
			local IniFileName = (GetDir #startupScripts) + "/ArktosBonesTools.ini"
			if ((getfiles IniFilename).count == 0) then
			(
				--ini file not exist create default setting
				BoneWriteIniFun()
			)	
			else
			(
				-- ini file exist and read settings from it
				IniFile = openfile IniFileName
				
				BoneTraject.checked = ReadValue IniFile
				BoneTraject.enabled = ReadValue IniFile
				
				BonesBBox.checked = ReadValue IniFile
				BonesBBox.enabled = ReadValue IniFile
				
				DelSRCObj.checked = ReadValue IniFile
				DelSRCObj.enabled = ReadValue IniFile
				
				DelObjs.checked = ReadValue IniFile
				DelObjs.enabled = ReadValue IniFile
				
				BoneRnd.checked = ReadValue IniFile
				BoneRnd.enabled = ReadValue IniFile
				
				BoneScaleMult.range = ReadValue IniFile
				BoneAffect.range = ReadValue IniFile
				BoneStep.range= ReadValue IniFile
				BoneEnvScale.range = ReadValue IniFile
				
				SkinAtFrame.range = ReadValue IniFile
				
				close IniFile
			)
		)
	)

createDialog AnimationToBonesBaker 210 455

)

-- Arktos Static Export
macroScript ArktosStaticExport
buttontext:"Static Object Export..." category:"ArktosInt"
(


	rollout ObjectExport "Static Object Export" width:210 height:560
	(
		button BtnSaveSet "SaveSettings" pos:[110,500] width:91 height:20
		button BtnExport "Export" pos:[110,530] width:90 height:20
		groupBox grp1 "BatchExportOptions" pos:[10,170] width:190 height:200
		groupBox grp2 "SceneOptions" pos:[10,10] width:190 height:150
		button BtnCancel "Cancel" pos:[10,530] width:91 height:20
		button BtnAbout1 "About" pos:[10,500] width:91 height:20
		label lbl3 "Input Path" pos:[20,270] width:60 height:20
		groupBox grp3 "ExportProgress" pos:[10,380] width:190 height:110
		progressBar PbScene "SceneExportProgress" pos:[20,460] width:170 height:16 color:(color 30 10 190)
		
		
		button BtnIn "..." pos:[150,290] width:40 height:20
		
		label lbl4 "Current Scene:" pos:[20,440] width:75 height:13
		label PercentScnDone "0%" pos:[95,440] width:50 height:16
		label lbl5 "Total:" pos:[20,400] width:29 height:17
		label PercentTotalDone "0%" pos:[50,400] width:50 height:20
		progressBar PbTotal "TotalExportProgress" pos:[20,420] width:170 height:16 color:(color 30 10 190)
		
		checkbox ExpSelObj "Export Only Selected Objects" pos:[20,30] width:170 height:20 checked:true
		checkbox IncSubFld "Include SubFolders" pos:[20,210] width:110 height:20 checked:true
		checkbox CopyTex "Copy Textures" pos:[20,50] width:170 height:20 checked:true
		checkbox ExpMat "Export Materials" pos:[20,70] width:170 height:20 checked:true
		checkbox ExpVColor "Export Vertex Color" pos:[20,90] width:170 height:20 checked:true
		checkbox DWarn "Disable Warnings" pos:[20,110] width:170 height:20 checked:true
		checkbox Shwlog "Show Log" pos:[20,130] width:170 height:20 checked:true
		checkbox BatcEnl "Batch Mode" pos:[20,190] width:170 height:20 checked:true
		checkbox ExpAnim "Export Animations if any" pos:[20,230] width:170 height:20 checked:true triState:2
		
		editText InputPath "" pos:[20,290] width:123 height:20 text: "Select Path..." readonly: true
		editText OutPath "" pos:[20,340] width:123 height:20 text: "Select Path..." readonly: true
		
		label lbl7 "Output Path" pos:[20,320] width:60 height:20
		
		button BtnOut "..." pos:[150,340] width:40 height:20
		
	
		
		-- Simply at this line start export
		fn MainExport =
		(
			
		)
		
		--Recursive Select File List
		fn getFilesRecursive root pattern =
		(
		dir_array = GetDirectories (root+"/*")
		for d in dir_array do
		join dir_array (GetDirectories (d+"/*"))
		my_files = #()
		for f in dir_array do
		join my_files (getFiles (f + pattern))
		my_files 
		)
		-- about dialog
		on BtnAbout1 pressed do
		(
			rollout AboutArktos "About" width:296 height:152
			(	 
				bitmap bmp1 "Bitmap" pos:[8,8] width:280 height:80 fileName: "ArktosLogo.bmp" 
				button btn1 "Ok" pos:[104,140] width:88 height:24
				label lbl13 "All Rights Reserved, 2013 Arktos Entertainment. v1.04" pos:[10,96] width:275 height:30 align:#right style_sunkenedge:true
				on btn1 pressed do destroyDialog(AboutArktos)
			)
			createDialog AboutArktos 296 172
		)
		
		--Write Ini file function start here
		fn WriteIniFun = (
		
			local IniFileName = (GetDir #startupScripts) + "/ArktosTools.ini"
	
			--ini file not exist create default settings
	
			local IniFile = Createfile IniFileName 
			
			format "%\n" ExpSelObj.checked  to:IniFile
			format "%\n" ExpSelObj.enabled  to:IniFile
			
			format "%\n" IncSubFld.checked  to:IniFile
			format "%\n" IncSubFld.enabled  to:IniFile
			
			format "%\n" CopyTex.checked  to:IniFile
			format "%\n" CopyTex.enabled  to:IniFile
			
			format "%\n" ExpMat.checked  to:IniFile
			format "%\n" ExpMat.enabled  to:IniFile
			
			format "%\n" ExpVColor.checked  to:IniFile
			format "%\n" ExpVColor.enabled  to:IniFile
			
			format "%\n" DWarn.checked  to:IniFile
			format "%\n" DWarn.enabled  to:IniFile
			
			format "%\n" Shwlog.checked  to:IniFile
			format "%\n" Shwlog.enabled  to:IniFile
			
			format "%\n" BatcEnl.checked  to:IniFile
			format "%\n" BatcEnl.enabled  to:IniFile
			
			format "%\n" ExpAnim.checked  to:IniFile
			format "%\n" ExpAnim.enabled  to:IniFile
			
			format "%\n" OpenPath  to:IniFile
			format "%\n" SavePath  to:IniFile
			
			format "%\n" InputPath.text  to:IniFile
			format "%\n" OutPath.text  to:IniFile
			
			close IniFile
			
			return IniFile
		)
		
		--save settings start here
		on btnSaveSet pressed do
		(
			WriteIniFun()
		)

		--First start save setings procedure
		on ObjectExport open do
		(
			local IniFileName = (GetDir #startupScripts) + "/ArktosTools.ini"
			if ((getfiles IniFilename).count == 0) then
			(
				--ini file not exist create default setting
				WriteIniFun()
			)	
		else
			(
				-- ini file exist and read settings from it
				IniFile = openfile IniFileName
			
				ExpSelObj.checked = ReadValue IniFile
				ExpSelObj.enabled = ReadValue IniFile
				
				IncSubFld.checked = ReadValue IniFile
				IncSubFld.enabled = ReadValue IniFile
				
				CopyTex.checked = ReadValue IniFile
				CopyTex.enabled = ReadValue IniFile
				
				ExpMat.checked = ReadValue IniFile
				ExpMat.enabled = ReadValue IniFile
				
				ExpVColor.checked = ReadValue IniFile
				ExpVColor.enabled = ReadValue IniFile
				
				DWarn.checked = ReadValue IniFile
				DWarn.enabled = ReadValue IniFile
				
				Shwlog.checked = ReadValue IniFile
				Shwlog.enabled = ReadValue IniFile
				
				BatcEnl.checked = ReadValue IniFile
				BatcEnl.enabled = ReadValue IniFile
				
				ExpAnim.checked = ReadValue IniFile
				ExpAnim.enabled = ReadValue IniFile
			
				OpenPath = ReadLine IniFile
				SavePath = ReadLine IniFile
			
				InputPath.text = ReadLine IniFile
				OutPath.text = ReadLine IniFile
			
			
			close IniFile
			)
		)
		
		-- close after Cancel Pressed
		on btnCancel pressed do destroyDialog(ObjectExport)
		
		-- Functions to Select paths for BatchExport Mode
		fn SInput =
		(
			OpenPath = getSavePath caption:"Select Input Directory:" initialDir:(getDir #export)
			if (OpenPath == undefined) then
			(
				OpenPath = #export
				InputPath.text = "Default 3DSMax Export Directory..."
			)
			else
			(
				InputPath.text = OpenPath
			)
		)
		
		fn SOutput =
		(			
			SavePath = getSavePath caption:"Select Output Directory:" initialDir:(getDir #export)
			if (SavePath == undefined) then
			(
				SavePath = #export
				OutPath.text = "Default 3DSMax Export Directory..."	
			)
			else
			(
				OutPath.text = SavePath
			)
		)
		
		-- Change\Select Batchexport Paths
		on BtnIn pressed do
		(
			OpenPath = SInput()
		)
		
		on BtnOut pressed do
		(
			SavePath = SOutput()
		)	
		
		-- Main export start Hire!
		on btnExport pressed do
		(
			-----------------------------------------------------------------------------------------
			-- Check for Batc\Single Scene Export Mode.
			
			if (BatcEnl.checked == false) then
			(
				if (SavePath == undefined or SavePath == "undefined") then SavePath = SOutput()
				
				-- Single Scene Export
				MainExport()
				
				-- Reset Progress "Scene" Bar
				PbScene.value = 0
				PercentScnDone.caption = "Done!"
				clearSelection()
				enableSceneRedraw()
			)
			else
			(
				-- Batch export
				-- Check for Path asigment
				if (OpenPath == undefined or OpenPath == "undefined") then OpenPath = SInput()
				if (SavePath == undefined or SavePath == "undefined") then SavePath =SOutput()
				
				--collect all max files in the dir.
				if (IncSubFld.checked == false) then
				(
					FileList = getFiles (OpenPath +"\\*.max") 
				)
				else
				(
					FileList = getFilesRecursive OpenPath "*.max"
				)
				
				--BarCounter asigment local
				local PBarB = 1
				
				--Main Batch Export Worker
				for CurrentFile in FileList do
				(
					--load the next file
					PbTotal.value = 100.*PBarB/FileList.count
					PercentTotalDone.caption = pbTotal.value as string + "%"
					loadMaxFile CurrentFile
						PBarB = PBarB +1
					MainExport()
				)
					-- Reset Progress "Scene" Bar
				PbScene.value = 0
				PercentScnDone.caption = "Done!"
				-- Reset Progress "Total" Bar
				PbTotal.value = 0
				PercentTotalDone.caption = "Done!"
				clearSelection()
				enableSceneRedraw()
				resetMaxFile #noPrompt
			)
		)
		--------------------------------------------------------------------------------------------------------------
	)	
	createDialog ObjectExport 210 560
)

-- Arktos Skeleton Export
macroScript ArktosSkeletonExport
buttontext:"Skeleton Export..." category:"ArktosInt"
(
	messagebox ("Skeleton Export will be implement later..") title: "Warning!"
)

-- Arktos Animation Export
macroScript ArktosAnimExport
buttontext:"Animation Export..." category:"ArktosInt"
(
	messagebox ("Animation Export will be implement later..") title: "Warning!"
)

-- Arktos Scene Export
macroScript ArktosScnExport
buttontext:"Scene Export..." category:"ArktosInt"
(
	messagebox ("Scene Export will be implement later..") title: "Warning!"
)



-- About Window
macroScript AboutArktos
buttontext:"About..." category:"ArktosInt"
(
	rollout AboutArktos "About" width:296 height:152
	(	 
		bitmap bmp1 "Bitmap" pos:[8,8] width:280 height:80 fileName: "ArktosLogo.bmp" 
		button btn1 "Ok" pos:[104,140] width:88 height:24
		label lbl13 "All Rights Reserved, 2013 Arktos Entertainment. v1.04" pos:[10,96] width:275 height:30 align:#right style_sunkenedge:true
		on btn1 pressed do destroyDialog(AboutArktos)
	)
	createDialog AboutArktos 296 172
)
	

--Rescale Mech
macroScript ArktosIntTools
buttontext:"Objects Batch Rescale..." category:"ArktosInt"
(
	rollout RescaleMech "Batch Objects Rescale " width:210 height:320
	(
		button BtnBatch "Batch" pos:[110,290] width:91 height:20
		button BtnScale "Scale" pos:[110,320] width:90 height:20
		editText RootBoneName "" pos:[16,150] width:174 height:20 text: "Mech_Root"
		label lbl2 "Root Bone Name" pos:[20,130] width:120 height:20
		groupBox grp1 "BatchOptions" pos:[10,10] width:190 height:90
		groupBox grp2 "MechOptions" pos:[10,110] width:190 height:100
		button BtnCancel "Cancel" pos:[10,320] width:91 height:20
		button BtnAbout "About" pos:[10,290] width:91 height:20
		label lbl3 "Input Path" pos:[20,50] width:110 height:20
		groupBox grp3 "BatchProgress" pos:[10,220] width:190 height:60
		progressBar pbTotal "ProgressBar" pos:[20,254] width:170 height:16
		editText BatchPath "" pos:[16,70] width:123 height:20 text: "Select Path..." readonly: true
		button BtnPath "..." pos:[150,70] width:40 height:20
		checkbox SubFld "Include SubFolders" pos:[20,30] width:170 height:20 checked:false
		label lbl4 "Done:" pos:[21,236] width:29 height:17
		label PercentDone "0%" pos:[52,236] width:50 height:16
		spinner ScaleSpin "" pos:[140,180] width:50 height:16 range:[0,100,1.25] type:#float
		label lbl6 "ScaleMultiply:" pos:[20,180] width:60 height:20
		
		--Recursive Select File List
		fn getFilesRecursive root pattern =
		(
			dir_array = GetDirectories (root+"/*")
			for d in dir_array do
			join dir_array (GetDirectories (d+"/*"))
			my_files = #()
			for f in dir_array do
			join my_files (getFiles (f + pattern))
			my_files 
		)
		
		-- function for Batch Path Selection
		fn SInput =
		(OpenPath = getSavePath caption:"Select Input Directory:" initialDir:(getDir #maxroot)
			if (OpenPath == undefined) then
			(
				OpenPath = #maxroot
				BatchPath.text = "Default 3DSMax Root..."
			)
			else
			(
				BatchPath.text = OpenPath
			)
		)
		
		fn MainScale =
		(
			ObjExist = getnodebyname "Mech_Pelvis"
			
			--Check for present Mech_pelvis bone
			if (ObjExist == undefined) then
			(
				-- bad programing need fix	
			)
			else
			(
				ObjExist1 = getnodebyname "Mech_Root"
				-- Check for allready scaled Mechs
				if (ObjExist1 == undefined) then
				(
					Point pos:[0,0,0] isSelected:on name:"Mech_Root"
					$.size = 1.2
					$.Box = on
					select $Mech_Pelvis
					$.parent = $Mech_Root
				)
				select $Mech_Root
				toolMode.coordsys #local
				scale $ [ScaleSpin.value,ScaleSpin.value,ScaleSpin.value]
			)
			
			clearSelection()
		)
		
		-- Select Path for Batch
		on BtnPath pressed do
		(
			OpenPath = SInput()
		)
		
		--	Run Main Scale Mech
		on BtnScale pressed do
		(	
			MainScale()
			ObjExist2 = getnodebyname "Mech_Pelvis"
			
			--Check for present Mech_pelvis bone
			if (ObjExist2 == undefined) then messagebox ("Mech_Pelvis Bone Not Found!") title: "Warning!"
		)
		
		-- Display About
		on BtnAbout pressed do
		(
			rollout AboutArktos "About" width:296 height:152
			(	 
				bitmap bmp1 "Bitmap" pos:[8,8] width:280 height:80 fileName: "ArktosLogo.bmp" 
				button btn1 "Ok" pos:[104,140] width:88 height:24
				label lbl13 "All Rights Reserved, 2013 Arktos Entertainment. v1.04" pos:[10,96] width:275 height:30 align:#right style_sunkenedge:true
				on btn1 pressed do destroyDialog(AboutArktos)
			)
			createDialog AboutArktos 296 172
		)
		
		-- Close All and Destroy Dialog
		on btnCancel pressed do destroyDialog(RescaleMech)
		
		-- Batch ScaleMech
		on BtnBatch pressed do
		(	
			
			if (OpenPath == undefined or OpenPath == "undefined") then OpenPath = SInput()
			
			--collect all max files in the dir.
			if (SubFld.checked == false) then
			(
				FileList = getFiles (OpenPath +"\\*.max") 
			)
			else
			(
				FileList = getFilesRecursive OpenPath "*.max"
				join FileList (getFiles (OpenPath +"\\*.max") )
			)
				
			local PBarB = 1
			for CurrentFile in FileList do
			(
				--load the next file
				pbTotal.value = 100.*PBarB/FileList.count
				PercentDone.caption = pbTotal.value as string + "%"
				loadMaxFile CurrentFile
				PBarB = PBarB +1
				
				-- call to mesh Scale Function
				MainScale()
				
				--save current max file
				-- resolve problem with no changed files please here or not:)
				ObjExist2 = getnodebyname "Mech_Pelvis"
			
				--Check for present Mech_pelvis bone
				if (ObjExist2 == undefined) then
				(
					
					if (maxFileName == undefined or maxFileName == "Untitled" or maxFileName == "") then
					(
						
						messagebox ("Wrong version max file!") title: "Error!"
					)
					else
					(
						messagebox ("Mech_Pelvis Bone Not Found! Skip file...") title: "Warning!"
					)
				)
				else
				(
					if (maxFileName == undefined or maxFileName == "Untitled" or maxFileName == "") then
					(
						
						messagebox ("Wrong version max file!") title: "Error!"
					)
					else
					(
						saveMaxFile CurrentFile
						--messagebox ("Wrong version max file!") title: "Error!"
					)
				)
			)
			
			-- Reset Progress Bar
			pbTotal.value = 0
			PercentDone.caption = "100%"
				
			--at the end reset Scene
			resetMaxFile #noPrompt
		)
	)
	createDialog RescaleMech 210 350
)

-- Create Main Menu Bar Dialogs and Menu
-- For complete earase old menu and Script Settings you need delete *.mrc MAX generated files from bottom path
-- Path where placed "temp" Max Meny *.mrc macroscrips
-- C:\Users\%UserName%\AppData\Local\Autodesk\3dsMax\2011 - 64bit\enu\UI\usermacros
(


	local mainMenu = menuMan.getMainMenuBar()
	local subMenu = menuMan.createMenu "ArktosTools"

	-- add mech rescale menu
	local myItem = menuMan.createActionItem "ArktosIntTools" "ArktosInt"
	myItem.setTitle "Batch Objects Rescale..."
	myItem.setUseCustomTitle true
	subMenu.addItem myItem -1
	
	-- add Static Obj Export
	local myItem1 = menuMan.createActionItem "ArktosStaticExport" "ArktosInt"
	myItem1.setTitle "Static Object Export..."
	myItem1.setUseCustomTitle true
	--subMenu.addItem myItem1 -1

	-- add Skeleton Export
	local myItem2 = menuMan.createActionItem "ArktosSkeletonExport" "ArktosInt"
	myItem2.setTitle "Skeleton Export..."
	myItem2.setUseCustomTitle true
	--subMenu.addItem myItem2 -2

	-- add Animation Export
	local myItem3 = menuMan.createActionItem "ArktosAnimExport" "ArktosInt"
	myItem3.setTitle "Animation Export..."
	myItem3.setUseCustomTitle true
	--subMenu.addItem myItem3 -3

	-- add Scene Export
	local myItem4 = menuMan.createActionItem "ArktosScnExport" "ArktosInt"
	myItem4.setTitle "Scene Export..."
	myItem4.setUseCustomTitle true
	--subMenu.addItem myItem4 -4

	-- add Capture To Bones Menu
	local myItem5 = menuMan.createActionItem "ArktosBoneCap" "ArktosInt"
	myItem5.setTitle "Animation To Bones..."
	myItem5.setUseCustomTitle true
	subMenu.addItem myItem5 -5

	-- add Reskin Menu
	local myItem6 = menuMan.createActionItem "ArktosReSkinner" "ArktosInt"
	myItem6.setTitle "Objects ReSkinner..."
	myItem6.setUseCustomTitle true
	subMenu.addItem myItem6 -6
	
	-- add About Menu
	local myItem7 = menuMan.createActionItem "AboutArktos" "ArktosInt"
	myItem7.setTitle "About..."
	myItem7.setUseCustomTitle true
	subMenu.addItem myItem7 -7

	local subMenuItem = menuMan.createSubMenuItem "ArktosTools" subMenu
	local exportSelectedIndex
	local addItem = true
	for	i = 1 to (mainMenu.numItems()) do
	(
		local item = mainMenu.getItem i
		local itemTitle = item.getTitle()
		if (itemTitle == "ArktosTools") then
		(
			addItem = false; exit
		)
		else if (itemTitle == "Help" or itemTitle == "&Help") then ( exportSelectedIndex = i )
	)
	if (addItem AND (exportSelectedIndex != undefined)) then
	(
		mainMenu.addItem subMenuItem (exportSelectedIndex+1)
	)
	menuMan.updateMenuBar()
)

